import time
import os
import serial
import json
import sys, termios, struct, fcntl
from Util import *
from Project import *
from Antenna import *
from PcuCommunicator import *
from WebServer import *

if (sys.hexversion < 0x020100f0): import TERMIOS
else: TERMIOS = termios
if (sys.hexversion < 0x020200f0): import FCNTL
else: FCNTL = fcntl
TIOCMBIS  = hasattr(TERMIOS, 'TIOCMBIS') and TERMIOS.TIOCMBIS or 0x5416
TIOCMBIC  = hasattr(TERMIOS, 'TIOCMBIC') and TERMIOS.TIOCMBIC or 0x5417
TIOCM_DTR = hasattr(TERMIOS, 'TIOCM_DTR') and TERMIOS.TIOCM_DTR or 0x002
TIOCM_RTS = hasattr(TERMIOS, 'TIOCM_RTS') and TERMIOS.TIOCM_RTS or 0x004
TIOCM_RTS_str = struct.pack('I', TIOCM_RTS)
TIOCM_DTR_str = struct.pack('I', TIOCM_DTR)
# block == false
#fcntl.ioctl(com, TIOCMBIS, TIOCM_DTR_str) 
# block == true
#fcntl.ioctl(com, TIOCMBIC, TIOCM_DTR_str)


from SerialCommunicator import *
    

def test0():
    # Test 0 - Repeat message.
    time.sleep(1)
    # print(str(time.time()))
    
def main():   
    # print("Main Function "+ str(time.time()))

    pj.Conf = System.LoadConf()
    print(pj.Conf)
    
    pj.PcuComm = PcuCommunicator("PcuComm");
    pj.PcuComm.Connect("/dev/ttyUSB5", 57600)
       
    # Util.UpdateEth0WithLog('192.168.1.3','255.255.255.0','192.168.1.254')
    System.CreateWebsocketJs()
    WS = WebServer();
    WS.Start() 
    
    
    
    while True:
        time.sleep(1)
        # print(pj.Ant.GetJson())
        # print(pj.Ant.GetArray())
        
 
# def main():
    # # print("Main Function "+ str(time.time()))
    
    # com = serial.Serial("/dev/ttyUSB5", 57600)
    # if com != None: print ("Connected to PCU.")
    # else: 
        # print ("Can't find to PCU.")
        # return
    
    
    # crc_error = 0 
    # Ant = Antenna('Antenna')
    
    # line = b""
    # while True:
        # # Test 0 - Repeat message.
        # # test0()
        
        # # Test 0 - Serial Test.
        # ch  = com.read(1)
        # line += ch 
        # if ch == b'\n':  
            # rcv = line.decode()
            # line = b""
            # if Util.CheckCRC(rcv):
                # # print(rcv)
                # rcvs = rcv.split(',')
                
                # if rcvs[2] == 'STS' : 
                    # Ant.DatProc(rcv)
                    # os.system('clear')
                    # # print(Ant.GetJson(12))
                    # print(Ant.GetArray())
                    # # print(Ant.Nmea.Rmc.GetArray())
                    # # print(Ant.Nmea.Gga.GetArray())
            # else:
                # if line != b"":
                    # crc_error += 1
                    # rint(line)
    # com.close()

if __name__ == "__main__":
	main()
    